// Copyright  2002 Microsoft Corporation.  All rights reserved. 
var id_OP = 0;
var id_CL = 1;
var id_QU = 2;
var id_GL = 3;
var id_NS = 4;
var id_EX = 5;
var id_SY = 6;
var id_IS = 7;
var id_PR = 8;
var id_PO = 9;
var id_NU = 10;
var id_AL = 11;
var id_ID = 12;
var id_IN = 13;
var id_HY = 14;
var id_BA = 15;
var id_BB = 16;
var id_B2 = 17;
var id_ZW = 18;
var id_CM = 19;
var id_AI = 20;
var id_BK = 21;
var id_CB = 22;
var id_CR = 23;
var id_LF = 24;
var id_SA = 25;
var id_SG = 26;
var id_SP = 27;
var id_XX = 28;
function get_brks( in_string ) {
		var ret = new Array( in_string.length );
		for( var i = 0; i < in_string.length; i++ ){
			var l = in_string.charCodeAt(i);
			var r = get_brk( l );
			ret[i] = r;
		}
		return ret;
}

function get_brk( v ) {

if(((v>=0xE000)&&(v<=0xF8FF))||
	((v>=0xF0000)&&(v<=0xFFFFD))||
	((v>=0x100000)&&(v<=0x10FFFD))
	){ return id_XX; }

if((v==0x0028)||
	(v==0x005B)||
	(v==0x007B)||
	(v==0x0F3A)||
	(v==0x0F3C)||
	(v==0x169B)||
	(v==0x201A)||
	(v==0x201E)||
	(v==0x2045)||
	(v==0x207D)||
	(v==0x208D)||
	(v==0x2329)||
	(v==0x3008)||
	(v==0x300A)||
	(v==0x300C)||
	(v==0x300E)||
	(v==0x3010)||
	(v==0x3014)||
	(v==0x3016)||
	(v==0x3018)||
	(v==0x301A)||
	(v==0x301D)||
	(v==0xFD3E)||
	(v==0xFE35)||
	(v==0xFE37)||
	(v==0xFE39)||
	(v==0xFE3B)||
	(v==0xFE3D)||
	(v==0xFE3F)||
	(v==0xFE41)||
	(v==0xFE43)||
	(v==0xFE59)||
	(v==0xFE5B)||
	(v==0xFE5D)||
	(v==0xFF08)||
	(v==0xFF3B)||
	(v==0xFF5B)||
	(v==0xFF62)
	){ return id_OP; }

if((v==0x0029)||
	(v==0x005D)||
	(v==0x007D)||
	(v==0x0F3B)||
	(v==0x0F3D)||
	(v==0x169C)||
	(v==0x2046)||
	(v==0x207E)||
	(v==0x208E)||
	(v==0x232A)||
	((v>=0x3001)&&(v<=0x3002))||
	(v==0x3009)||
	(v==0x300B)||
	(v==0x300D)||
	(v==0x300F)||
	(v==0x3011)||
	(v==0x3015)||
	(v==0x3017)||
	(v==0x3019)||
	(v==0x301B)||
	((v>=0x301E)&&(v<=0x301F))||
	(v==0xFD3F)||
	(v==0xFE36)||
	(v==0xFE38)||
	(v==0xFE3A)||
	(v==0xFE3C)||
	(v==0xFE3E)||
	(v==0xFE40)||
	(v==0xFE42)||
	(v==0xFE44)||
	(v==0xFE50)||
	(v==0xFE52)||
	(v==0xFE5A)||
	(v==0xFE5C)||
	(v==0xFE5E)||
	(v==0xFF09)||
	(v==0xFF0C)||
	(v==0xFF0E)||
	(v==0xFF3D)||
	(v==0xFF5D)||
	(v==0xFF61)||
	(v==0xFF63)||
	(v==0xFF64)
	){ return id_CL; }

if((v==0x0022)||
	(v==0x0027)||
	(v==0x00AB)||
	(v==0x00BB)||
	(v==0x2018)||
	(v==0x2019)||
	((v>=0x201B)&&(v<=0x201C))||
	(v==0x201D)||
	(v==0x201F)||
	(v==0x2039)||
	(v==0x203A)
	){ return id_QU; }

if((v==0x00A0)||
	(v==0x0F0C)||
	(v==0x2007)||
	(v==0x2011)||
	(v==0x202F)||
	(v==0xFEFF)
	){ return id_GL; }

if(((v>=0x0E5A)&&(v<=0x0E5B))||
	(v==0x17D4)||
	((v>=0x17D6)&&(v<=0x17DA))||
	(v==0x203C)||
	(v==0x2044)||
	(v==0x3005)||
	(v==0x301C)||
	(v==0x3041)||
	(v==0x3043)||
	(v==0x3045)||
	(v==0x3047)||
	(v==0x3049)||
	(v==0x3063)||
	(v==0x3083)||
	(v==0x3085)||
	(v==0x3087)||
	(v==0x308E)||
	((v>=0x309B)&&(v<=0x309C))||
	((v>=0x309D)&&(v<=0x309E))||
	(v==0x30A1)||
	(v==0x30A3)||
	(v==0x30A5)||
	(v==0x30A7)||
	(v==0x30A9)||
	(v==0x30C3)||
	(v==0x30E3)||
	(v==0x30E5)||
	(v==0x30E7)||
	(v==0x30EE)||
	((v>=0x30F5)&&(v<=0x30F6))||
	(v==0x30FB)||
	(v==0x30FD)||
	((v>=0xFE54)&&(v<=0xFE55))||
	((v>=0xFF1A)&&(v<=0xFF1B))||
	(v==0xFF65)||
	((v>=0xFF67)&&(v<=0xFF6F))||
	(v==0xFF70)||
	((v>=0xFF9E)&&(v<=0xFF9F))
	){ return id_NS; }

if((v==0x0021)||
	(v==0x003F)||
	((v>=0xFE56)&&(v<=0xFE57))||
	(v==0xFF01)||
	(v==0xFF1F)
	){ return id_EX; }

if((v==0x002F)|| 
	(v==0x00A9)|| 
	(v==0x00AE)|| 
	(v==0x2122)
	){ return id_SY; }

if((v==0x002C)||
	(v==0x002E)||
	((v>=0x003A)&&(v<=0x003B))||
	(v==0x0589)
	){ return id_IS; }

if((v==0x0024)||
	(v==0x002B)||
	(v==0x005C)||
	((v>=0x00A3)&&(v<=0x00A5))||
	(v==0x00B1)||
	((v>=0x09F2)&&(v<=0x09F3))||
	(v==0x0E3F)||
	(v==0x17DB)||
	((v>=0x20A0)&&(v<=0x20A6))||
	((v>=0x20A8)&&(v<=0x20AF))||
	(v==0x2116)||
	((v>=0x2212)&&(v<=0x2213))||
	(v==0xFE69)||
	(v==0xFF04)||
	(v==0xFFE1)||
	((v>=0xFFE5)&&(v<=0xFFE6))
	){ return id_PR; }


if((v==0x0025)||
	(v==0x00A2)||
	(v==0x00B0)||
	((v>=0x2030)&&(v<=0x2037))||
	(v==0x20A7)||
	(v==0x2103)||
	(v==0x2109)||
	(v==0x2126)||
	(v==0xFE6A)||
	(v==0xFF05)||
	(v==0xFFE0)
	){ return id_PO; }


if(((v>=0x0030)&&(v<=0x0039))||
	((v>=0x0660)&&(v<=0x0669))||
	((v>=0x06F0)&&(v<=0x06F9))||
	((v>=0x0966)&&(v<=0x096F))||
	((v>=0x09E6)&&(v<=0x09EF))||
	((v>=0x0A66)&&(v<=0x0A6F))||
	((v>=0x0AE6)&&(v<=0x0AEF))||
	((v>=0x0B66)&&(v<=0x0B6F))||
	((v>=0x0BE7)&&(v<=0x0BEF))||
	((v>=0x0C66)&&(v<=0x0C6F))||
	((v>=0x0CE6)&&(v<=0x0CEF))||
	((v>=0x0D66)&&(v<=0x0D6F))||
	((v>=0x0E50)&&(v<=0x0E59))||
	((v>=0x0ED0)&&(v<=0x0ED9))||
	((v>=0x0F20)&&(v<=0x0F29))||
	((v>=0x1040)&&(v<=0x1049))||
	((v>=0x1369)&&(v<=0x1371))||
	((v>=0x17E0)&&(v<=0x17E9))||
	((v>=0x1810)&&(v<=0x1819))||
	((v>=0x1D7CE)&&(v<=0x1D7FF))
	){ return id_NU; }

if((v==0x0023)||
	(v==0x0026)||
	(v==0x002A)||
	((v>=0x003C)&&(v<=0x003E))||
	(v==0x0040)||
	((v>=0x0041)&&(v<=0x005A))||
	(v==0x005E)||
	(v==0x005F)||
	(v==0x0060)||
	((v>=0x0061)&&(v<=0x007A))||
	(v==0x007E)||
	(v==0x00A6)||
	(v==0x00AC)||
	(v==0x00AF)||
	(v==0x00B5)||
	((v>=0x00C0)&&(v<=0x00C5))||
	((v>=0x00C7)&&(v<=0x00CF))||
	((v>=0x00D1)&&(v<=0x00D6))||
	((v>=0x00D9)&&(v<=0x00DD))||
	((v>=0x00E2)&&(v<=0x00E5))||
	(v==0x00E7)||
	(v==0x00EB)||
	((v>=0x00EE)&&(v<=0x00EF))||
	(v==0x00F1)||
	((v>=0x00F4)&&(v<=0x00F6))||
	(v==0x00FB)||
	(v==0x00FD)||
	((v>=0x00FF)&&(v<=0x0100))||
	((v>=0x0102)&&(v<=0x0110))||
	(v==0x0112)||
	((v>=0x0114)&&(v<=0x011A))||
	((v>=0x011C)&&(v<=0x0125))||
	((v>=0x0128)&&(v<=0x012A))||
	((v>=0x012C)&&(v<=0x0130))||
	((v>=0x0134)&&(v<=0x0137))||
	((v>=0x0139)&&(v<=0x013E))||
	(v==0x0143)||
	((v>=0x0145)&&(v<=0x0147))||
	((v>=0x014B)&&(v<=0x014C))||
	((v>=0x014E)&&(v<=0x0151))||
	((v>=0x0154)&&(v<=0x0165))||
	((v>=0x0168)&&(v<=0x016A))||
	((v>=0x016C)&&(v<=0x01BA))||
	(v==0x01BB)||
	((v>=0x01BC)&&(v<=0x01BF))||
	((v>=0x01C0)&&(v<=0x01C3))||
	((v>=0x01C4)&&(v<=0x01CD))||
	(v==0x01CF)||
	(v==0x01D1)||
	(v==0x01D3)||
	(v==0x01D5)||
	(v==0x01D7)||
	(v==0x01D9)||
	(v==0x01DB)||
	((v>=0x01DD)&&(v<=0x021F))||
	((v>=0x0222)&&(v<=0x0233))||
	(v==0x0250)||
	((v>=0x0252)&&(v<=0x0260))||
	((v>=0x0262)&&(v<=0x02AD))||
	((v>=0x02B0)&&(v<=0x02B8))||
	((v>=0x02B9)&&(v<=0x02BA))||
	((v>=0x02BB)&&(v<=0x02C1))||
	((v>=0x02C2)&&(v<=0x02C6))||
	((v>=0x02CE)&&(v<=0x02CF))||
	(v==0x02D1)||
	((v>=0x02D2)&&(v<=0x02D7))||
	(v==0x02DC)||
	((v>=0x02DE)&&(v<=0x02DF))||
	((v>=0x02E0)&&(v<=0x02E4))||
	((v>=0x02E5)&&(v<=0x02ED))||
	(v==0x02EE)||
	((v>=0x0374)&&(v<=0x0375))||
	(v==0x037A)||
	(v==0x037E)||
	((v>=0x0384)&&(v<=0x0385))||
	(v==0x0386)||
	(v==0x0387)||
	((v>=0x0388)&&(v<=0x038A))||
	(v==0x038C)||
	((v>=0x038E)&&(v<=0x0390))||
	((v>=0x03AA)&&(v<=0x03B0))||
	(v==0x03C2)||
	((v>=0x03CA)&&(v<=0x03CE))||
	((v>=0x03D0)&&(v<=0x03D7))||
	((v>=0x03DA)&&(v<=0x03F5))||
	(v==0x0400)||
	((v>=0x0402)&&(v<=0x040F))||
	(v==0x0450)||
	((v>=0x0452)&&(v<=0x0481))||
	(v==0x0482)||
	((v>=0x048C)&&(v<=0x04C4))||
	((v>=0x04C7)&&(v<=0x04C8))||
	((v>=0x04CB)&&(v<=0x04CC))||
	((v>=0x04D0)&&(v<=0x04F5))||
	((v>=0x04F8)&&(v<=0x04F9))||
	((v>=0x0531)&&(v<=0x0556))||
	(v==0x0559)||
	((v>=0x055A)&&(v<=0x055F))||
	((v>=0x0561)&&(v<=0x0587))||
	(v==0x05BE)||
	(v==0x05C0)||
	(v==0x05C3)||
	((v>=0x05D0)&&(v<=0x05EA))||
	((v>=0x05F0)&&(v<=0x05F2))||
	((v>=0x05F3)&&(v<=0x05F4))||
	(v==0x060C)||
	(v==0x061B)||
	(v==0x061F)||
	((v>=0x0621)&&(v<=0x063A))||
	(v==0x0640)||
	((v>=0x0641)&&(v<=0x064A))||
	((v>=0x066A)&&(v<=0x066D))||
	((v>=0x0671)&&(v<=0x06D3))||
	(v==0x06D4)||
	(v==0x06D5)||
	((v>=0x06E5)&&(v<=0x06E6))||
	(v==0x06E9)||
	((v>=0x06FA)&&(v<=0x06FC))||
	((v>=0x06FD)&&(v<=0x06FE))||
	((v>=0x0700)&&(v<=0x070D))||
	(v==0x0710)||
	((v>=0x0712)&&(v<=0x072C))||
	((v>=0x0780)&&(v<=0x07A5))||
	((v>=0x0905)&&(v<=0x0939))||
	(v==0x093D)||
	(v==0x0950)||
	((v>=0x0958)&&(v<=0x0961))||
	((v>=0x0964)&&(v<=0x0965))||
	(v==0x0970)||
	((v>=0x0985)&&(v<=0x098C))||
	((v>=0x098F)&&(v<=0x0990))||
	((v>=0x0993)&&(v<=0x09A8))||
	((v>=0x09AA)&&(v<=0x09B0))||
	(v==0x09B2)||
	((v>=0x09B6)&&(v<=0x09B9))||
	((v>=0x09DC)&&(v<=0x09DD))||
	((v>=0x09DF)&&(v<=0x09E1))||
	((v>=0x09F0)&&(v<=0x09F1))||
	((v>=0x09F4)&&(v<=0x09F9))||
	(v==0x09FA)||
	((v>=0x0A05)&&(v<=0x0A0A))||
	((v>=0x0A0F)&&(v<=0x0A10))||
	((v>=0x0A13)&&(v<=0x0A28))||
	((v>=0x0A2A)&&(v<=0x0A30))||
	((v>=0x0A32)&&(v<=0x0A33))||
	((v>=0x0A35)&&(v<=0x0A36))||
	((v>=0x0A38)&&(v<=0x0A39))||
	((v>=0x0A59)&&(v<=0x0A5C))||
	(v==0x0A5E)||
	((v>=0x0A72)&&(v<=0x0A74))||
	((v>=0x0A85)&&(v<=0x0A8B))||
	(v==0x0A8D)||
	((v>=0x0A8F)&&(v<=0x0A91))||
	((v>=0x0A93)&&(v<=0x0AA8))||
	((v>=0x0AAA)&&(v<=0x0AB0))||
	((v>=0x0AB2)&&(v<=0x0AB3))||
	((v>=0x0AB5)&&(v<=0x0AB9))||
	(v==0x0ABD)||
	(v==0x0AD0)||
	(v==0x0AE0)||
	((v>=0x0B05)&&(v<=0x0B0C))||
	((v>=0x0B0F)&&(v<=0x0B10))||
	((v>=0x0B13)&&(v<=0x0B28))||
	((v>=0x0B2A)&&(v<=0x0B30))||
	((v>=0x0B32)&&(v<=0x0B33))||
	((v>=0x0B36)&&(v<=0x0B39))||
	(v==0x0B3D)||
	((v>=0x0B5C)&&(v<=0x0B5D))||
	((v>=0x0B5F)&&(v<=0x0B61))||
	(v==0x0B70)||
	((v>=0x0B85)&&(v<=0x0B8A))||
	((v>=0x0B8E)&&(v<=0x0B90))||
	((v>=0x0B92)&&(v<=0x0B95))||
	((v>=0x0B99)&&(v<=0x0B9A))||
	(v==0x0B9C)||
	((v>=0x0B9E)&&(v<=0x0B9F))||
	((v>=0x0BA3)&&(v<=0x0BA4))||
	((v>=0x0BA8)&&(v<=0x0BAA))||
	((v>=0x0BAE)&&(v<=0x0BB5))||
	((v>=0x0BB7)&&(v<=0x0BB9))||
	((v>=0x0BF0)&&(v<=0x0BF2))||
	((v>=0x0C05)&&(v<=0x0C0C))||
	((v>=0x0C0E)&&(v<=0x0C10))||
	((v>=0x0C12)&&(v<=0x0C28))||
	((v>=0x0C2A)&&(v<=0x0C33))||
	((v>=0x0C35)&&(v<=0x0C39))||
	((v>=0x0C60)&&(v<=0x0C61))||
	((v>=0x0C85)&&(v<=0x0C8C))||
	((v>=0x0C8E)&&(v<=0x0C90))||
	((v>=0x0C92)&&(v<=0x0CA8))||
	((v>=0x0CAA)&&(v<=0x0CB3))||
	((v>=0x0CB5)&&(v<=0x0CB9))||
	(v==0x0CDE)||
	((v>=0x0CE0)&&(v<=0x0CE1))||
	((v>=0x0D05)&&(v<=0x0D0C))||
	((v>=0x0D0E)&&(v<=0x0D10))||
	((v>=0x0D12)&&(v<=0x0D28))||
	((v>=0x0D2A)&&(v<=0x0D39))||
	((v>=0x0D60)&&(v<=0x0D61))||
	((v>=0x0D85)&&(v<=0x0D96))||
	((v>=0x0D9A)&&(v<=0x0DB1))||
	((v>=0x0DB3)&&(v<=0x0DBB))||
	(v==0x0DBD)||
	((v>=0x0DC0)&&(v<=0x0DC6))||
	(v==0x0DF4)||
	(v==0x0E4F)||
	(v==0x0F00)||
	((v>=0x0F01)&&(v<=0x0F03))||
	((v>=0x0F04)&&(v<=0x0F0A))||
	((v>=0x0F0D)&&(v<=0x0F12))||
	((v>=0x0F13)&&(v<=0x0F17))||
	((v>=0x0F1A)&&(v<=0x0F1F))||
	((v>=0x0F2A)&&(v<=0x0F33))||
	(v==0x0F34)||
	(v==0x0F36)||
	(v==0x0F38)||
	((v>=0x0F40)&&(v<=0x0F47))||
	((v>=0x0F49)&&(v<=0x0F6A))||
	(v==0x0F85)||
	((v>=0x0F88)&&(v<=0x0F8B))||
	((v>=0x0FBE)&&(v<=0x0FC5))||
	((v>=0x0FC7)&&(v<=0x0FCC))||
	(v==0x0FCF)||
	((v>=0x104A)&&(v<=0x104F))||
	((v>=0x10A0)&&(v<=0x10C5))||
	((v>=0x10D0)&&(v<=0x10F6))||
	(v==0x10FB)||
	((v>=0x1200)&&(v<=0x1206))||
	((v>=0x1208)&&(v<=0x1246))||
	(v==0x1248)||
	((v>=0x124A)&&(v<=0x124D))||
	((v>=0x1250)&&(v<=0x1256))||
	(v==0x1258)||
	((v>=0x125A)&&(v<=0x125D))||
	((v>=0x1260)&&(v<=0x1286))||
	(v==0x1288)||
	((v>=0x128A)&&(v<=0x128D))||
	((v>=0x1290)&&(v<=0x12AE))||
	(v==0x12B0)||
	((v>=0x12B2)&&(v<=0x12B5))||
	((v>=0x12B8)&&(v<=0x12BE))||
	(v==0x12C0)||
	((v>=0x12C2)&&(v<=0x12C5))||
	((v>=0x12C8)&&(v<=0x12CE))||
	((v>=0x12D0)&&(v<=0x12D6))||
	((v>=0x12D8)&&(v<=0x12EE))||
	((v>=0x12F0)&&(v<=0x130E))||
	(v==0x1310)||
	((v>=0x1312)&&(v<=0x1315))||
	((v>=0x1318)&&(v<=0x131E))||
	((v>=0x1320)&&(v<=0x1346))||
	((v>=0x1348)&&(v<=0x135A))||
	((v>=0x1362)&&(v<=0x1368))||
	((v>=0x1372)&&(v<=0x137C))||
	((v>=0x13A0)&&(v<=0x13F4))||
	((v>=0x1401)&&(v<=0x166C))||
	((v>=0x166D)&&(v<=0x166E))||
	((v>=0x166F)&&(v<=0x1676))||
	((v>=0x1681)&&(v<=0x169A))||
	((v>=0x16A0)&&(v<=0x16EA))||
	((v>=0x16EB)&&(v<=0x16ED))||
	((v>=0x16EE)&&(v<=0x16F0))||
	(v==0x17DC)||
	((v>=0x1800)&&(v<=0x1805))||
	((v>=0x1807)&&(v<=0x180A))||
	((v>=0x1820)&&(v<=0x1842))||
	(v==0x1843)||
	((v>=0x1844)&&(v<=0x1877))||
	((v>=0x1880)&&(v<=0x18A8))||
	((v>=0x1E00)&&(v<=0x1E9B))||
	((v>=0x1EA0)&&(v<=0x1EF9))||
	((v>=0x1F00)&&(v<=0x1F15))||
	((v>=0x1F18)&&(v<=0x1F1D))||
	((v>=0x1F20)&&(v<=0x1F45))||
	((v>=0x1F48)&&(v<=0x1F4D))||
	((v>=0x1F50)&&(v<=0x1F57))||
	(v==0x1F59)||
	(v==0x1F5B)||
	(v==0x1F5D)||
	((v>=0x1F5F)&&(v<=0x1F7D))||
	((v>=0x1F80)&&(v<=0x1FB4))||
	((v>=0x1FB6)&&(v<=0x1FBC))||
	(v==0x1FBD)||
	(v==0x1FBE)||
	((v>=0x1FBF)&&(v<=0x1FC1))||
	((v>=0x1FC2)&&(v<=0x1FC4))||
	((v>=0x1FC6)&&(v<=0x1FCC))||
	((v>=0x1FCD)&&(v<=0x1FCF))||
	((v>=0x1FD0)&&(v<=0x1FD3))||
	((v>=0x1FD6)&&(v<=0x1FDB))||
	((v>=0x1FDD)&&(v<=0x1FDF))||
	((v>=0x1FE0)&&(v<=0x1FEC))||
	((v>=0x1FED)&&(v<=0x1FEF))||
	((v>=0x1FF2)&&(v<=0x1FF4))||
	((v>=0x1FF6)&&(v<=0x1FFC))||
	((v>=0x1FFD)&&(v<=0x1FFE))||
	(v==0x2017)||
	((v>=0x2022)&&(v<=0x2023))||
	(v==0x2038)||
	((v>=0x203D)&&(v<=0x203E))||
	((v>=0x203F)&&(v<=0x2040))||
	((v>=0x2041)&&(v<=0x2043))||
	((v>=0x2048)&&(v<=0x204D))||
	(v==0x2070)||
	((v>=0x2075)&&(v<=0x2079))||
	((v>=0x207A)&&(v<=0x207C))||
	(v==0x2080)||
	((v>=0x2085)&&(v<=0x2089))||
	((v>=0x208A)&&(v<=0x208C))||
	((v>=0x2100)&&(v<=0x2101))||
	(v==0x2102)||
	(v==0x2104)||
	(v==0x2106)||
	(v==0x2107)||
	(v==0x2108)||
	((v>=0x210A)&&(v<=0x2112))||
	(v==0x2114)||
	(v==0x2115)||
	((v>=0x2117)&&(v<=0x2118))||
	((v>=0x2119)&&(v<=0x211D))||
	((v>=0x211E)&&(v<=0x2120))||
	(v==0x2123)||
	(v==0x2124)||
	(v==0x2125)||
	(v==0x2127)||
	(v==0x2128)||
	(v==0x2129)||
	(v==0x212A)||
	((v>=0x212C)&&(v<=0x212D))||
	(v==0x212E)||
	((v>=0x212F)&&(v<=0x2131))||
	(v==0x2132)||
	((v>=0x2133)&&(v<=0x2134))||
	((v>=0x2135)&&(v<=0x2138))||
	(v==0x2139)||
	(v==0x213A)||
	(v==0x2153)||
	((v>=0x2156)&&(v<=0x215A))||
	((v>=0x215C)&&(v<=0x215D))||
	(v==0x215F)||
	((v>=0x216C)&&(v<=0x216F))||
	((v>=0x217A)&&(v<=0x2183))||
	((v>=0x219A)&&(v<=0x219B))||
	((v>=0x219C)&&(v<=0x219F))||
	(v==0x21A0)||
	((v>=0x21A1)&&(v<=0x21A2))||
	(v==0x21A3)||
	((v>=0x21A4)&&(v<=0x21A5))||
	(v==0x21A6)||
	((v>=0x21A7)&&(v<=0x21AD))||
	(v==0x21AE)||
	((v>=0x21AF)&&(v<=0x21CD))||
	((v>=0x21CE)&&(v<=0x21CF))||
	((v>=0x21D0)&&(v<=0x21D1))||
	(v==0x21D3)||
	((v>=0x21D5)&&(v<=0x21F3))||
	(v==0x2201)||
	((v>=0x2204)&&(v<=0x2206))||
	((v>=0x2209)&&(v<=0x220A))||
	((v>=0x220C)&&(v<=0x220E))||
	(v==0x2210)||
	(v==0x2214)||
	((v>=0x2216)&&(v<=0x2219))||
	((v>=0x221B)&&(v<=0x221C))||
	((v>=0x2221)&&(v<=0x2222))||
	(v==0x2224)||
	(v==0x2226)||
	(v==0x222D)||
	((v>=0x222F)&&(v<=0x2233))||
	((v>=0x2238)&&(v<=0x223B))||
	((v>=0x223E)&&(v<=0x2247))||
	((v>=0x2249)&&(v<=0x224B))||
	((v>=0x224D)&&(v<=0x2251))||
	((v>=0x2253)&&(v<=0x225F))||
	((v>=0x2262)&&(v<=0x2263))||
	((v>=0x2268)&&(v<=0x2269))||
	((v>=0x226C)&&(v<=0x226D))||
	((v>=0x2270)&&(v<=0x2281))||
	((v>=0x2284)&&(v<=0x2285))||
	((v>=0x2288)&&(v<=0x2294))||
	((v>=0x2296)&&(v<=0x2298))||
	((v>=0x229A)&&(v<=0x22A4))||
	((v>=0x22A6)&&(v<=0x22BE))||
	((v>=0x22C0)&&(v<=0x22F1))||
	((v>=0x2300)&&(v<=0x2307))||
	((v>=0x2308)&&(v<=0x230B))||
	((v>=0x230C)&&(v<=0x2311))||
	((v>=0x2313)&&(v<=0x231F))||
	((v>=0x2320)&&(v<=0x2321))||
	((v>=0x2322)&&(v<=0x2328))||
	((v>=0x232B)&&(v<=0x237B))||
	((v>=0x237D)&&(v<=0x239A))||
	((v>=0x2400)&&(v<=0x2426))||
	((v>=0x2440)&&(v<=0x244A))||
	((v>=0x24C0)&&(v<=0x24CF))||
	(v==0x24EA)||
	((v>=0x254C)&&(v<=0x254F))||
	((v>=0x2575)&&(v<=0x257F))||
	((v>=0x2590)&&(v<=0x2591))||
	(v==0x25A2)||
	((v>=0x25AA)&&(v<=0x25B1))||
	((v>=0x25B4)&&(v<=0x25B5))||
	((v>=0x25B8)&&(v<=0x25BB))||
	((v>=0x25BE)&&(v<=0x25BF))||
	((v>=0x25C2)&&(v<=0x25C5))||
	((v>=0x25C9)&&(v<=0x25CA))||
	((v>=0x25CC)&&(v<=0x25CD))||
	((v>=0x25D2)&&(v<=0x25E1))||
	((v>=0x25E6)&&(v<=0x25EE))||
	((v>=0x25F0)&&(v<=0x25F7))||
	((v>=0x2600)&&(v<=0x2604))||
	((v>=0x2607)&&(v<=0x2608))||
	((v>=0x260A)&&(v<=0x260D))||
	((v>=0x2610)&&(v<=0x2613))||
	((v>=0x2619)&&(v<=0x261B))||
	(v==0x261D)||
	((v>=0x261F)&&(v<=0x263F))||
	(v==0x2641)||
	((v>=0x2643)&&(v<=0x265F))||
	(v==0x2662)||
	(v==0x2666)||
	(v==0x266B)||
	(v==0x266E)||
	((v>=0x2670)&&(v<=0x2671))||
	((v>=0x2701)&&(v<=0x2704))||
	((v>=0x2706)&&(v<=0x2709))||
	((v>=0x270C)&&(v<=0x2727))||
	((v>=0x2729)&&(v<=0x274B))||
	(v==0x274D)||
	((v>=0x274F)&&(v<=0x2752))||
	(v==0x2756)||
	((v>=0x2758)&&(v<=0x275E))||
	((v>=0x2761)&&(v<=0x2767))||
	((v>=0x2776)&&(v<=0x2793))||
	(v==0x2794)||
	((v>=0x2798)&&(v<=0x27AF))||
	((v>=0x27B1)&&(v<=0x27BE))||
	((v>=0x2800)&&(v<=0x28FF))||
	((v>=0xFB00)&&(v<=0xFB06))||
	((v>=0xFB13)&&(v<=0xFB17))||
	(v==0xFB1D)||
	((v>=0xFB1F)&&(v<=0xFB28))||
	(v==0xFB29)||
	((v>=0xFB2A)&&(v<=0xFB36))||
	((v>=0xFB38)&&(v<=0xFB3C))||
	(v==0xFB3E)||
	((v>=0xFB40)&&(v<=0xFB41))||
	((v>=0xFB43)&&(v<=0xFB44))||
	((v>=0xFB46)&&(v<=0xFBB1))||
	((v>=0xFBD3)&&(v<=0xFD3D))||
	((v>=0xFD50)&&(v<=0xFD8F))||
	((v>=0xFD92)&&(v<=0xFDC7))||
	((v>=0xFDF0)&&(v<=0xFDFB))||
	((v>=0xFE70)&&(v<=0xFE72))||
	(v==0xFE74)||
	((v>=0xFE76)&&(v<=0xFEFC))||
	(v==0xFF66)||
	((v>=0xFF71)&&(v<=0xFF9D))||
	((v>=0xFFA0)&&(v<=0xFFBE))||
	((v>=0xFFC2)&&(v<=0xFFC7))||
	((v>=0xFFCA)&&(v<=0xFFCF))||
	((v>=0xFFD2)&&(v<=0xFFD7))||
	((v>=0xFFDA)&&(v<=0xFFDC))||
	(v==0xFFE8)||
	((v>=0xFFE9)&&(v<=0xFFEC))||
	((v>=0xFFED)&&(v<=0xFFEE))||
	((v>=0x10300)&&(v<=0x1031E))||
	((v>=0x10320)&&(v<=0x10323))||
	((v>=0x10330)&&(v<=0x10349))||
	(v==0x1034A)||
	((v>=0x10400)&&(v<=0x10425))||
	((v>=0x10428)&&(v<=0x1044D))||
	((v>=0x1D000)&&(v<=0x1D0F5))||
	((v>=0x1D100)&&(v<=0x1D126))||
	((v>=0x1D12A)&&(v<=0x1D164))||
	((v>=0x1D16A)&&(v<=0x1D16C))||
	((v>=0x1D183)&&(v<=0x1D184))||
	((v>=0x1D18C)&&(v<=0x1D1A9))||
	((v>=0x1D1AE)&&(v<=0x1D1DD))||
	((v>=0x1D400)&&(v<=0x1D454))||
	((v>=0x1D456)&&(v<=0x1D49C))||
	((v>=0x1D49E)&&(v<=0x1D49F))||
	(v==0x1D4A2)||
	((v>=0x1D4A5)&&(v<=0x1D4A6))||
	((v>=0x1D4A9)&&(v<=0x1D4AC))||
	((v>=0x1D4AE)&&(v<=0x1D4B9))||
	(v==0x1D4BB)||
	((v>=0x1D4BD)&&(v<=0x1D4C0))||
	((v>=0x1D4C2)&&(v<=0x1D4C3))||
	((v>=0x1D4C5)&&(v<=0x1D505))||
	((v>=0x1D507)&&(v<=0x1D50A))||
	((v>=0x1D50D)&&(v<=0x1D514))||
	((v>=0x1D516)&&(v<=0x1D51C))||
	((v>=0x1D51E)&&(v<=0x1D539))||
	((v>=0x1D53B)&&(v<=0x1D53E))||
	((v>=0x1D540)&&(v<=0x1D544))||
	(v==0x1D546)||
	((v>=0x1D54A)&&(v<=0x1D550))||
	((v>=0x1D552)&&(v<=0x1D6A3))||
	((v>=0x1D6A8)&&(v<=0x1D6C0))||
	(v==0x1D6C1)||
	((v>=0x1D6C2)&&(v<=0x1D6DA))||
	(v==0x1D6DB)||
	((v>=0x1D6DC)&&(v<=0x1D6FA))||
	(v==0x1D6FB)||
	((v>=0x1D6FC)&&(v<=0x1D714))||
	(v==0x1D715)||
	((v>=0x1D716)&&(v<=0x1D734))||
	(v==0x1D735)||
	((v>=0x1D736)&&(v<=0x1D74E))||
	(v==0x1D74F)||
	((v>=0x1D750)&&(v<=0x1D76E))||
	(v==0x1D76F)||
	((v>=0x1D770)&&(v<=0x1D788))||
	(v==0x1D789)||
	((v>=0x1D78A)&&(v<=0x1D7A8))||
	(v==0x1D7A9)||
	((v>=0x1D7AA)&&(v<=0x1D7C2))||
	(v==0x1D7C3)||
	((v>=0x1D7C4)&&(v<=0x1D7C9))
	){ return id_AL; }


if(((v>=0x1100)&&(v<=0x1159))||
	(v==0x115F)||
	((v>=0x2E80)&&(v<=0x2E99))||
	((v>=0x2E9B)&&(v<=0x2EF3))||
	((v>=0x2F00)&&(v<=0x2FD5))||
	((v>=0x2FF0)&&(v<=0x2FFB))||
	(v==0x3000)||
	(v==0x3003)||
	(v==0x3004)||
	(v==0x3006)||
	(v==0x3007)||
	((v>=0x3012)&&(v<=0x3013))||
	(v==0x3020)||
	((v>=0x3021)&&(v<=0x3029))||
	(v==0x3030)||
	((v>=0x3031)&&(v<=0x3035))||
	((v>=0x3036)&&(v<=0x3037))||
	((v>=0x3038)&&(v<=0x303A))||
	((v>=0x303E)&&(v<=0x303F))||
	(v==0x3042)||
	(v==0x3044)||
	(v==0x3046)||
	(v==0x3048)||
	((v>=0x304A)&&(v<=0x3062))||
	((v>=0x3064)&&(v<=0x3082))||
	(v==0x3084)||
	(v==0x3086)||
	((v>=0x3088)&&(v<=0x308D))||
	((v>=0x308F)&&(v<=0x3094))||
	(v==0x30A2)||
	(v==0x30A4)||
	(v==0x30A6)||
	(v==0x30A8)||
	((v>=0x30AA)&&(v<=0x30C2))||
	((v>=0x30C4)&&(v<=0x30E2))||
	(v==0x30E4)||
	(v==0x30E6)||
	((v>=0x30E8)&&(v<=0x30ED))||
	((v>=0x30EF)&&(v<=0x30F4))||
	((v>=0x30F7)&&(v<=0x30FA))||
	(v==0x30FC)||
	(v==0x30FE)||
	((v>=0x3105)&&(v<=0x312C))||
	((v>=0x3131)&&(v<=0x318E))||
	((v>=0x3190)&&(v<=0x3191))||
	((v>=0x3192)&&(v<=0x3195))||
	((v>=0x3196)&&(v<=0x319F))||
	((v>=0x31A0)&&(v<=0x31B7))||
	((v>=0x3200)&&(v<=0x321C))||
	((v>=0x3220)&&(v<=0x3229))||
	((v>=0x322A)&&(v<=0x3243))||
	((v>=0x3260)&&(v<=0x327B))||
	(v==0x327F)||
	((v>=0x3280)&&(v<=0x3289))||
	((v>=0x328A)&&(v<=0x32B0))||
	((v>=0x32C0)&&(v<=0x32CB))||
	((v>=0x32D0)&&(v<=0x32FE))||
	((v>=0x3300)&&(v<=0x3376))||
	((v>=0x337B)&&(v<=0x33DD))||
	((v>=0x33E0)&&(v<=0x33FE))||
	((v>=0x3400)&&(v<=0x4DB5))||
	((v>=0x4E00)&&(v<=0x9FA5))||
	((v>=0xA000)&&(v<=0xA48C))||
	((v>=0xA490)&&(v<=0xA4A1))||
	((v>=0xA4A4)&&(v<=0xA4B3))||
	((v>=0xA4B5)&&(v<=0xA4C0))||
	((v>=0xA4C2)&&(v<=0xA4C4))||
	(v==0xA4C6)||
	((v>=0xAC00)&&(v<=0xD7A3))||
	((v>=0xF900)&&(v<=0xFA2D))||
	(v==0xFE30)||
	((v>=0xFE31)&&(v<=0xFE32))||
	((v>=0xFE33)&&(v<=0xFE34))||
	((v>=0xFE49)&&(v<=0xFE4C))||
	((v>=0xFE4D)&&(v<=0xFE4F))||
	(v==0xFE51)||
	(v==0xFE58)||
	((v>=0xFE5F)&&(v<=0xFE61))||
	(v==0xFE62)||
	(v==0xFE63)||
	((v>=0xFE64)&&(v<=0xFE66))||
	(v==0xFE68)||
	(v==0xFE6B)||
	((v>=0xFF02)&&(v<=0xFF03))||
	((v>=0xFF06)&&(v<=0xFF07))||
	(v==0xFF0A)||
	(v==0xFF0B)||
	(v==0xFF0D)||
	(v==0xFF0F)||
	((v>=0xFF10)&&(v<=0xFF19))||
	((v>=0xFF1C)&&(v<=0xFF1E))||
	(v==0xFF20)||
	((v>=0xFF21)&&(v<=0xFF3A))||
	(v==0xFF3C)||
	(v==0xFF3E)||
	(v==0xFF3F)||
	(v==0xFF40)||
	((v>=0xFF41)&&(v<=0xFF5A))||
	(v==0xFF5C)||
	(v==0xFF5E)||
	(v==0xFFE2)||
	(v==0xFFE3)||
	(v==0xFFE4)||
	((v>=0x20000)&&(v<=0x2A6D6))||
	((v>=0x2F800)&&(v<=0x2FA1D))
	){ return id_ID; }

if((v>=0x2024)&&(v<=0x2026))
{ return id_IN; }


if(v==0x002D)
{ return id_HY; }


if(((v>=0x0000)&&(v<=0x0008))||
	(v==0x000B)||
	((v>=0x000E)&&(v<=0x001F))||
	((v>=0x007F)&&(v<=0x009F))||
	((v>=0x0300)&&(v<=0x034E))||
	((v>=0x0360)&&(v<=0x0362))||
	((v>=0x0483)&&(v<=0x0486))||
	((v>=0x0488)&&(v<=0x0489))||
	((v>=0x0591)&&(v<=0x05A1))||
	((v>=0x05A3)&&(v<=0x05B9))||
	((v>=0x05BB)&&(v<=0x05BD))||
	(v==0x05BF)||
	((v>=0x05C1)&&(v<=0x05C2))||
	(v==0x05C4)||
	((v>=0x064B)&&(v<=0x0655))||
	(v==0x0670)||
	((v>=0x06D6)&&(v<=0x06DC))||
	((v>=0x06DD)&&(v<=0x06DE))||
	((v>=0x06DF)&&(v<=0x06E4))||
	((v>=0x06E7)&&(v<=0x06E8))||
	((v>=0x06EA)&&(v<=0x06ED))||
	(v==0x070F)||
	(v==0x0711)||
	((v>=0x0730)&&(v<=0x074A))||
	((v>=0x07A6)&&(v<=0x07B0))||
	((v>=0x0901)&&(v<=0x0902))||
	(v==0x0903)||
	(v==0x093C)||
	((v>=0x093E)&&(v<=0x0940))||
	((v>=0x0941)&&(v<=0x0948))||
	((v>=0x0949)&&(v<=0x094C))||
	(v==0x094D)||
	((v>=0x0951)&&(v<=0x0954))||
	((v>=0x0962)&&(v<=0x0963))||
	(v==0x0981)||
	((v>=0x0982)&&(v<=0x0983))||
	(v==0x09BC)||
	((v>=0x09BE)&&(v<=0x09C0))||
	((v>=0x09C1)&&(v<=0x09C4))||
	((v>=0x09C7)&&(v<=0x09C8))||
	((v>=0x09CB)&&(v<=0x09CC))||
	(v==0x09CD)||
	(v==0x09D7)||
	((v>=0x09E2)&&(v<=0x09E3))||
	(v==0x0A02)||
	(v==0x0A3C)||
	((v>=0x0A3E)&&(v<=0x0A40))||
	((v>=0x0A41)&&(v<=0x0A42))||
	((v>=0x0A47)&&(v<=0x0A48))||
	((v>=0x0A4B)&&(v<=0x0A4D))||
	((v>=0x0A70)&&(v<=0x0A71))||
	((v>=0x0A81)&&(v<=0x0A82))||
	(v==0x0A83)||
	(v==0x0ABC)||
	((v>=0x0ABE)&&(v<=0x0AC0))||
	((v>=0x0AC1)&&(v<=0x0AC5))||
	((v>=0x0AC7)&&(v<=0x0AC8))||
	(v==0x0AC9)||
	((v>=0x0ACB)&&(v<=0x0ACC))||
	(v==0x0ACD)||
	(v==0x0B01)||
	((v>=0x0B02)&&(v<=0x0B03))||
	(v==0x0B3C)||
	(v==0x0B3E)||
	(v==0x0B3F)||
	(v==0x0B40)||
	((v>=0x0B41)&&(v<=0x0B43))||
	((v>=0x0B47)&&(v<=0x0B48))||
	((v>=0x0B4B)&&(v<=0x0B4C))||
	(v==0x0B4D)||
	(v==0x0B56)||
	(v==0x0B57)||
	(v==0x0B82)||
	(v==0x0B83)||
	((v>=0x0BBE)&&(v<=0x0BBF))||
	(v==0x0BC0)||
	((v>=0x0BC1)&&(v<=0x0BC2))||
	((v>=0x0BC6)&&(v<=0x0BC8))||
	((v>=0x0BCA)&&(v<=0x0BCC))||
	(v==0x0BCD)||
	(v==0x0BD7)||
	((v>=0x0C01)&&(v<=0x0C03))||
	((v>=0x0C3E)&&(v<=0x0C40))||
	((v>=0x0C41)&&(v<=0x0C44))||
	((v>=0x0C46)&&(v<=0x0C48))||
	((v>=0x0C4A)&&(v<=0x0C4D))||
	((v>=0x0C55)&&(v<=0x0C56))||
	((v>=0x0C82)&&(v<=0x0C83))||
	(v==0x0CBE)||
	(v==0x0CBF)||
	((v>=0x0CC0)&&(v<=0x0CC4))||
	(v==0x0CC6)||
	((v>=0x0CC7)&&(v<=0x0CC8))||
	((v>=0x0CCA)&&(v<=0x0CCB))||
	((v>=0x0CCC)&&(v<=0x0CCD))||
	((v>=0x0CD5)&&(v<=0x0CD6))||
	((v>=0x0D02)&&(v<=0x0D03))||
	((v>=0x0D3E)&&(v<=0x0D40))||
	((v>=0x0D41)&&(v<=0x0D43))||
	((v>=0x0D46)&&(v<=0x0D48))||
	((v>=0x0D4A)&&(v<=0x0D4C))||
	(v==0x0D4D)||
	(v==0x0D57)||
	((v>=0x0D82)&&(v<=0x0D83))||
	(v==0x0DCA)||
	((v>=0x0DCF)&&(v<=0x0DD1))||
	((v>=0x0DD2)&&(v<=0x0DD4))||
	(v==0x0DD6)||
	((v>=0x0DD8)&&(v<=0x0DDF))||
	((v>=0x0DF2)&&(v<=0x0DF3))||
	(v==0x0E31)||
	((v>=0x0E34)&&(v<=0x0E3A))||
	((v>=0x0E47)&&(v<=0x0E4E))||
	(v==0x0EB1)||
	((v>=0x0EB4)&&(v<=0x0EB9))||
	((v>=0x0EBB)&&(v<=0x0EBC))||
	((v>=0x0EC8)&&(v<=0x0ECD))||
	((v>=0x0F18)&&(v<=0x0F19))||
	(v==0x0F35)||
	(v==0x0F37)||
	(v==0x0F39)||
	((v>=0x0F3E)&&(v<=0x0F3F))||
	((v>=0x0F71)&&(v<=0x0F7E))||
	(v==0x0F7F)||
	((v>=0x0F80)&&(v<=0x0F84))||
	((v>=0x0F86)&&(v<=0x0F87))||
	((v>=0x0F90)&&(v<=0x0F97))||
	((v>=0x0F99)&&(v<=0x0FBC))||
	(v==0x0FC6)||
	(v==0x102C)||
	((v>=0x102D)&&(v<=0x1030))||
	(v==0x1031)||
	(v==0x1032)||
	((v>=0x1036)&&(v<=0x1037))||
	(v==0x1038)||
	(v==0x1039)||
	((v>=0x1056)&&(v<=0x1057))||
	((v>=0x1058)&&(v<=0x1059))||
	((v>=0x1160)&&(v<=0x11A2))||
	((v>=0x11A8)&&(v<=0x11F9))||
	((v>=0x17B4)&&(v<=0x17B6))||
	((v>=0x17B7)&&(v<=0x17BD))||
	((v>=0x17BE)&&(v<=0x17C5))||
	(v==0x17C6)||
	((v>=0x17C7)&&(v<=0x17C8))||
	((v>=0x17C9)&&(v<=0x17D3))||
	((v>=0x180B)&&(v<=0x180E))||
	(v==0x18A9)||
	((v>=0x200C)&&(v<=0x200F))||
	((v>=0x202A)&&(v<=0x202E))||
	((v>=0x206A)&&(v<=0x206F))||
	((v>=0x20D0)&&(v<=0x20DC))||
	((v>=0x20DD)&&(v<=0x20E0))||
	(v==0x20E1)||
	((v>=0x20E2)&&(v<=0x20E3))||
	((v>=0x302A)&&(v<=0x302F))||
	((v>=0x3099)&&(v<=0x309A))||
	(v==0xFB1E)||
	((v>=0xFE20)&&(v<=0xFE23))||
	((v>=0xFFF9)&&(v<=0xFFFB))||
	((v>=0x1D165)&&(v<=0x1D166))||
	((v>=0x1D167)&&(v<=0x1D169))||
	((v>=0x1D16D)&&(v<=0x1D172))||
	((v>=0x1D173)&&(v<=0x1D17A))||
	((v>=0x1D17B)&&(v<=0x1D182))||
	((v>=0x1D185)&&(v<=0x1D18B))||
	((v>=0x1D1AA)&&(v<=0x1D1AD))||
	(v==0xE0001)||
	((v>=0xE0020)&&(v<=0xE007F))
	){ return id_CM; }


if((v==0x00B4)||
	(v==0x02C8)||
	(v==0x02CC)||
	(v==0x1806)
	){ return id_BB; }


if((v==0x0009)||
	(v==0x007C)||
	(v==0x00AD)||
	(v==0x058A)||
	(v==0x0F0B)||
	(v==0x1361)||
	(v==0x1680)||
	(v==0x17D5)||
	((v>=0x2000)&&(v<=0x2006))||
	((v>=0x2008)&&(v<=0x200A))||
	(v==0x2010)||
	((v>=0x2012)&&(v<=0x2013))||
	(v==0x2027)
	){ return id_BA; }

if(v==0x0020)
{ return id_SP; }

if((v==0x000C)||
	(v==0x2028)||
	(v==0x2029)
	){ return id_BK; }

if(v==0x000D)
{ return id_CR; }

if(v==0x000A)
{ return id_LF; }

if(v==0xFFFC)
{ return id_CB; }

if(((v>=0x0E01)&&(v<=0x0E30))||
	((v>=0x0E32)&&(v<=0x0E33))||
	((v>=0x0E40)&&(v<=0x0E45))||
	(v==0x0E46)||
	((v>=0x0E81)&&(v<=0x0E82))||
	(v==0x0E84)||
	((v>=0x0E87)&&(v<=0x0E88))||
	(v==0x0E8A)||
	(v==0x0E8D)||
	((v>=0x0E94)&&(v<=0x0E97))||
	((v>=0x0E99)&&(v<=0x0E9F))||
	((v>=0x0EA1)&&(v<=0x0EA3))||
	(v==0x0EA5)||
	(v==0x0EA7)||
	((v>=0x0EAA)&&(v<=0x0EAB))||
	((v>=0x0EAD)&&(v<=0x0EB0))||
	((v>=0x0EB2)&&(v<=0x0EB3))||
	(v==0x0EBD)||
	((v>=0x0EC0)&&(v<=0x0EC4))||
	(v==0x0EC6)||
	((v>=0x0EDC)&&(v<=0x0EDD))||
	((v>=0x1000)&&(v<=0x1021))||
	((v>=0x1023)&&(v<=0x1027))||
	((v>=0x1029)&&(v<=0x102A))||
	((v>=0x1050)&&(v<=0x1055))||
	((v>=0x1780)&&(v<=0x17B3))
	){ return id_SA; }

if((v==0x00A1)||
	(v==0x00A7)||
	(v==0x00A8)||
	(v==0x00AA)||
	((v>=0x00B2)&&(v<=0x00B3))||
	(v==0x00B6)||
	(v==0x00B7)||
	(v==0x00B8)||
	(v==0x00B9)||
	(v==0x00BA)||
	((v>=0x00BC)&&(v<=0x00BE))||
	(v==0x00BF)||
	(v==0x00C6)||
	(v==0x00D0)||
	(v==0x00D7)||
	(v==0x00D8)||
	((v>=0x00DE)&&(v<=0x00E1))||
	(v==0x00E6)||
	((v>=0x00E8)&&(v<=0x00EA))||
	((v>=0x00EC)&&(v<=0x00ED))||
	(v==0x00F0)||
	((v>=0x00F2)&&(v<=0x00F3))||
	(v==0x00F7)||
	((v>=0x00F8)&&(v<=0x00FA))||
	(v==0x00FC)||
	(v==0x00FE)||
	(v==0x0101)||
	(v==0x0111)||
	(v==0x0113)||
	(v==0x011B)||
	((v>=0x0126)&&(v<=0x0127))||
	(v==0x012B)||
	((v>=0x0131)&&(v<=0x0133))||
	(v==0x0138)||
	((v>=0x013F)&&(v<=0x0142))||
	(v==0x0144)||
	((v>=0x0148)&&(v<=0x014A))||
	(v==0x014D)||
	((v>=0x0152)&&(v<=0x0153))||
	((v>=0x0166)&&(v<=0x0167))||
	(v==0x016B)||
	(v==0x01CE)||
	(v==0x01D0)||
	(v==0x01D2)||
	(v==0x01D4)||
	(v==0x01D6)||
	(v==0x01D8)||
	(v==0x01DA)||
	(v==0x01DC)||
	(v==0x0251)||
	(v==0x0261)||
	(v==0x02C7)||
	((v>=0x02C9)&&(v<=0x02CB))||
	(v==0x02CD)||
	(v==0x02D0)||
	((v>=0x02D8)&&(v<=0x02DB))||
	(v==0x02DD)||
	((v>=0x0391)&&(v<=0x03A1))||
	((v>=0x03A3)&&(v<=0x03A9))||
	((v>=0x03B1)&&(v<=0x03C1))||
	((v>=0x03C3)&&(v<=0x03C9))||
	(v==0x0401)||
	((v>=0x0410)&&(v<=0x044F))||
	(v==0x0451)||
	(v==0x2015)||
	(v==0x2016)||
	((v>=0x2020)&&(v<=0x2021))||
	(v==0x203B)||
	(v==0x2074)||
	(v==0x207F)||
	((v>=0x2081)&&(v<=0x2084))||
	(v==0x2105)||
	(v==0x2113)||
	(v>=0x2121)||
	(v==0x212B)||
	((v>=0x2154)&&(v<=0x2155))||
	(v==0x215B)||
	(v==0x215E)||
	((v>=0x2160)&&(v<=0x216B))||
	((v>=0x2170)&&(v<=0x2179))||
	((v>=0x2190)&&(v<=0x2194))||
	((v>=0x2195)&&(v<=0x2199))||
	(v==0x21D2)||
	(v==0x21D4)||
	(v==0x2200)||
	((v>=0x2202)&&(v<=0x2203))||
	((v>=0x2207)&&(v<=0x2208))||
	(v==0x220B)||
	(v==0x220F)||
	(v==0x2211)||
	(v==0x2215)||
	(v==0x221A)||
	((v>=0x221D)&&(v<=0x2220))||
	(v==0x2223)||
	(v==0x2225)||
	((v>=0x2227)&&(v<=0x222C))||
	(v==0x222E)||
	((v>=0x2234)&&(v<=0x2237))||
	((v>=0x223C)&&(v<=0x223D))||
	(v==0x2248)||
	(v==0x224C)||
	(v==0x2252)||
	((v>=0x2260)&&(v<=0x2261))||
	((v>=0x2264)&&(v<=0x2267))||
	((v>=0x226A)&&(v<=0x226B))||
	((v>=0x226E)&&(v<=0x226F))||
	((v>=0x2282)&&(v<=0x2283))||
	((v>=0x2286)&&(v<=0x2287))||
	(v==0x2295)||
	(v==0x2299)||
	(v==0x22A5)||
	(v==0x22BF)||
	(v==0x2312)||
	((v>=0x2460)&&(v<=0x249B))||
	((v>=0x249C)&&(v<=0x24BF))||
	((v>=0x24D0)&&(v<=0x24E9))||
	((v>=0x2500)&&(v<=0x254B))||
	((v>=0x2550)&&(v<=0x2574))||
	((v>=0x2580)&&(v<=0x258F))||
	((v>=0x2592)&&(v<=0x2595))||
	((v>=0x25A0)&&(v<=0x25A1))||
	((v>=0x25A3)&&(v<=0x25A9))||
	((v>=0x25B2)&&(v<=0x25B3))||
	(v==0x25B6)||
	(v==0x25B7)||
	((v>=0x25BC)&&(v<=0x25BD))||
	(v==0x25C0)||
	(v==0x25C1)||
	((v>=0x25C6)&&(v<=0x25C8))||
	(v==0x25CB)||
	((v>=0x25CE)&&(v<=0x25D1))||
	((v>=0x25E2)&&(v<=0x25E5))||
	(v==0x25EF)||
	((v>=0x2605)&&(v<=0x2606))||
	(v==0x2609)||
	((v>=0x260E)&&(v<=0x260F))||
	(v==0x261C)||
	(v==0x261E)||
	(v==0x2640)||
	(v==0x2642)||
	((v>=0x2660)&&(v<=0x2661))||
	((v>=0x2663)&&(v<=0x2665))||
	((v>=0x2667)&&(v<=0x266A))||
	((v>=0x266C)&&(v<=0x266D))||
	(v==0x266F)||
	(v==0xFFFD)
	){ return id_AI; }


if(v==0x2014)
{ return id_B2; }


if((v>=0xD800)&&(v<=0xDFFF))
{ return id_SG; }

if(v==0x200B)
{ return id_ZW; }

return id_XX;

}