//////////////////////////////////////////////////////////////////////////////
//
// Copyright  2002-2003, Microsoft Corporation.  All rights reserved.
//
// File: Appart.js
//
// Description: Global constants for various viewer graphics.
//
//////////////////////////////////////////////////////////////////////////////

var ART_PATH = "appart/";
var VIEWER_ART_PATH = "viewer/" + ART_PATH;

//MV CHANGE - added banner link art placeholders back in - TODO may need to check with design about getting something new
var IMG_BANNER_LINK_BTN_NORMAL = VIEWER_ART_PATH + "banner_link_btn_norm.gif";
var IMG_BANNER_LINK_BTN_DOWN = VIEWER_ART_PATH + "banner_link_btn_down.gif";
var IMG_BANNER_LINK_BTN_RO = VIEWER_ART_PATH + "banner_link_btn_ro.gif";
//END MV CHANGE

var IMG_BRANDING = VIEWER_ART_PATH + "1px.gif";
var IMG_TOC_BTN_NORMAL = VIEWER_ART_PATH + "openTOC_stat.gif";
var IMG_TOC_BTN_DOWN = VIEWER_ART_PATH + "openTOC_down.gif";
var IMG_TOC_BTN_RO = VIEWER_ART_PATH + "openTOC_roll.gif";
var IMG_TOC_OPEN_BTN_NORMAL = VIEWER_ART_PATH + "closeTOC_stat.gif";
var IMG_TOC_OPEN_BTN_DOWN = VIEWER_ART_PATH + "closeTOC_down.gif";
var IMG_TOC_OPEN_BTN_RO = VIEWER_ART_PATH + "closeTOC_roll.gif";
var IMG_TOC_DIVIDE = VIEWER_ART_PATH + "toc_divide.gif";
var IMG_MENU_DIVIDE = VIEWER_ART_PATH + "menu_divider.gif";
var IMG_ONE_PIXEL = ART_PATH + "1px.gif";
var IMG_TOC_SEPARATOR = VIEWER_ART_PATH + "toc_divider.gif";
var IMG_CONTENT_WHEEL_TOPBAND = VIEWER_ART_PATH + "wheel_top_band.gif";
var IMG_WHEEL_NOTES_SEPARATOR = VIEWER_ART_PATH + "toc_divider.gif";
var IMG_PREVIOUS_BTN_NORMAL = VIEWER_ART_PATH + "back_stat.gif";
var IMG_PREVIOUS_BTN_DOWN = VIEWER_ART_PATH + "back_down.gif";
var IMG_PREVIOUS_BTN_RO = VIEWER_ART_PATH + "back_roll.gif";
var IMG_PREVIOUS_BTN_DISABLED = VIEWER_ART_PATH + "back_gray.gif";
var IMG_NEXT_BTN_NORMAL = VIEWER_ART_PATH + "fw_stat.gif";
var IMG_NEXT_BTN_DOWN = VIEWER_ART_PATH + "fw_down.gif";
var IMG_NEXT_BTN_RO = VIEWER_ART_PATH + "fw_roll.gif";
var IMG_NEXT_BTN_DISABLED = VIEWER_ART_PATH + "fw_gray.gif";
var IMG_HELP_ABOUT_BRANDING = ART_PATH + "msl_logo.jpg";
var IMG_WAIT_ANIMATION = ART_PATH + "please_wait.gif";
var IMG_BIG_MSLOGO = ART_PATH + "mslogo.gif";
var IMG_STATUS_COMPLETED = ART_PATH + "completed.gif";
var IMG_STATUS_INCOMPLETE = ART_PATH + "incomplete.gif";
var IMG_STATUS_PASSED = ART_PATH + "passed.gif";
var IMG_STATUS_FAILED = ART_PATH + "failed.gif";
var IMG_STATUS_BROWSED = ART_PATH + "browsed.gif";
var IMG_STATUS_NOT_ATTEMPTED = ART_PATH + "not_attempted.gif";
var IMG_STATUS_CURRENT_NODE = ART_PATH + "current_node.gif";
var IMG_STATUS_CURRENT_NODE_RLT = ART_PATH + "current_node_rtl.gif";

var IMG_TRANSPARENT_BLOCK = ART_PATH + "block.gif";
var IMG_BTM_BNR_LFT = VIEWER_ART_PATH + "bottom_lt_corner.gif";
var IMG_BTM_BNR_RT = VIEWER_ART_PATH + "bottom_rt_corner.gif";
var IMG_BTM_BNR_MID = VIEWER_ART_PATH + "bottom_tile.gif";
var IMG_NAV_HELP_BTN = ART_PATH + "nav_help_button.gif";

var IMG_COURSE_NAV_HELP = "../" + ART_PATH + "Course_Navigation_Help.jpg";

var IMG_NAV_HELP_ICONVIEW = "../" + ART_PATH + "icon_View.jpg";
var IMG_NAV_HELP_TEXTVIEW = "../" + ART_PATH + "text_View.jpg";
var IMG_NAV_HELP_TOGGLE1 = "../" + ART_PATH + "toggle1.jpg";
var IMG_NAV_HELP_TOGGLE2 = "../" + ART_PATH + "toggle2.jpg";
var IMG_NAV_HELP_VERT_LN = "../" + ART_PATH + "1px.gif";
var IMG_NAV_HELP_ICON_READ = "../" + ART_PATH + "icon_read.jpg";
var IMG_NAV_HELP_ICON_WATCH = "../" + ART_PATH + "icon_watch.jpg";
var IMG_NAV_HELP_ICON_INTERACT = "../" + ART_PATH + "icon_interact.jpg";
var IMG_NAV_HELP_ICON_PLAY = "../" + ART_PATH + "icon_play.jpg";
var IMG_NAV_HELP_ICON_TRY = "../" + ART_PATH + "icon_try.jpg";
var IMG_NAV_HELP_WHEEL = "../" + ART_PATH + "wheel.jpg";


