//////////////////////////////////////////////////////////////////////////////
//
// Copyright  2002-2003, Microsoft Corporation.  All rights reserved.
//
// File: Keycodes.js
//
// Description: Global constants that represent various keycode values
//
//////////////////////////////////////////////////////////////////////////////

var ASCII_KEYCODE_TAB = 9;
var ASCII_KEYCODE_ENTER = 13;
var ASCII_KEYCODE_ESC = 27;
var ASCII_KEYCODE_SPACE = 32;
var ASCII_KEYCODE_PGUP = 33;
var ASCII_KEYCODE_PGDN = 34;
var ASCII_KEYCODE_END = 35;
var ASCII_KEYCODE_HOME = 36;
var ASCII_KEYCODE_ARROW_LEFT = 37;
var ASCII_KEYCODE_ARROW_UP = 38;
var ASCII_KEYCODE_ARROW_RIGHT = 39;
var ASCII_KEYCODE_ARROW_DOWN = 40;
var ASCII_KEYCODE_F11 = 122;
var ASCII_KEYCODE_CTRL_J = 10;
var ASCII_KEYCODE_CTRL_Q = 17;
var ASCII_KEYCODE_CTRL_1 = 49;
var ASCII_KEYCODE_CTRL_2 = 50;
var ASCII_KEYCODE_CTRL_3 = 51;
var ASCII_KEYCODE_CTRL_4 = 52;
var MOUSE_BUTTON_LEFT = 1;
var MOUSE_BUTTON_RIGHT = 2;