// Copyright  2002 Microsoft Corporation.  All rights reserved.
var index_target_obj = null;
var page_prev_target_obj = null;
var page_next_target_obj = null;

var index_target_obj2 = null;
var page_prev_target_obj2 = null;
var page_next_target_obj2 = null;

var containing_target_obj = null;
var scope_target_obj = null;

var bSecondPager = true;

function pgr_set_indexer_target_obj( obj ){
	if ( obj == null )	return null;
	index_target_obj = obj;
	return true;
}
function pgr_set_page_prev_target_obj( obj ){
	if ( obj == null )	return null;
	page_prev_target_obj = obj;
	return true;
}
function pgr_set_page_next_target_obj( obj ){
	if ( obj == null )	return null;
	page_next_target_obj = obj;
	return true;
}

function pgr_set_indexer_target_obj2( obj ){
	if ( obj == null )	return null;
	index_target_obj2 = obj;
	return true;
}
function pgr_set_page_prev_target_obj2( obj ){
	if ( obj == null )	return null;
	page_prev_target_obj2 = obj;
	return true;
}
function pgr_set_page_next_target_obj2( obj ){
	if ( obj == null )	return null;
	page_next_target_obj2 = obj;
	return true;
}

function pgr_set_containing_target_obj( obj ){
	if ( obj == null )	return null;
	containing_target_obj = obj;
	return true;
}
function pgr_set_scope_target_obj( obj ){
	if ( obj == null )	return null;
	scope_target_obj = obj;
	return true;
}

function hide_page_objs(){
	if ( scope_target_obj != null ) scope_target_obj.style.display = "none";
	if ( containing_target_obj != null ) containing_target_obj.style.display = "none";
	if ( index_target_obj != null ) index_target_obj.style.display = "none";
	if ( page_prev_target_obj != null ) page_prev_target_obj.style.display = "none";
	if ( page_next_target_obj != null ) page_next_target_obj.style.display = "none";
	if ( index_target_obj2 != null ) index_target_obj2.style.display = "none";
	if ( page_prev_target_obj2 != null ) page_prev_target_obj2.style.display = "none";
	if ( page_next_target_obj2 != null ) page_next_target_obj2.style.display = "none";

}

function show_page_objs(){
	if ( scope_target_obj != null ) scope_target_obj.style.display = "inline";
	if ( containing_target_obj != null ) containing_target_obj.style.display = "inline";
	if ( index_target_obj != null ) index_target_obj.style.display = "inline";
	if ( page_prev_target_obj != null ) page_prev_target_obj.style.display = "inline";
	if ( page_next_target_obj != null ) page_next_target_obj.style.display = "inline";
	if ( index_target_obj2 != null ) index_target_obj2.style.display = "inline";
	if ( page_prev_target_obj2 != null ) page_prev_target_obj2.style.display = "inline";
	if ( page_next_target_obj2 != null ) page_next_target_obj2.style.display = "inline";
}

function pgr_create_scope(){

	if ( client_search == null ) return;
	if ( scope_target_obj == null ) return;
	var win = scope_target_obj.document.parentWindow;
	if ( win == null ) return;
	scope_target_obj.innerHTML = "";

	var type = ""; var scope = ""; 
	switch( client_search.searchtype ) {
		case 3: type = LBL_SEARCHTYPE_EXACT_PHRASE; break;
		case 2: type = LBL_SEARCHTYPE_ANY_WORD; break;
		case 0: type = LBL_SEARCHTYPE_ALL_BOOLEAN; break;
		default: type = LBL_SEARCHTYPE_ALL_WORDS;
	}

//NOTE !! knows about results document element id, idSearchLibrary
	var blibrary = document.all("idSearchLibrary").checked;
	if ( blibrary == true )	scope = LBL_LIBRARY_SEARCH_RESULTS_SCOPE;
	else	scope = LBL_COURSE_SEARCH_RESULTS_SCOPE;

	var inner_txt = c_results_scope_str;
	var expstr = "%t";
	var expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace(expobj, type.toLowerCase() );
	expstr = "%s";
	expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace(expobj, scope );

	expstr = "%q";
	expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace(expobj, client_search.containing );
	expstr = "%e1";
	expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace(expobj, c_pager_status_emphasischar1 );
	expstr = "%e2";
	expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace(expobj, c_pager_status_emphasischar2 );

	expstr = "&";
	expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace( expobj, "&amp;" );

	expstr = "<";
	expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace( expobj, "&lt;" );

	expstr = ">";
	expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace( expobj, "&gt;" );

	expstr = "\n";
	expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace( expobj, "" );

	scope_target_obj.innerHTML = inner_txt + "<br /><br />";
	show_page_objs();
}

function pgr_create_containing(){

	if ( client_search == null ) return;
	if ( containing_target_obj == null ) return;
	var win = containing_target_obj.document.parentWindow;
	if ( win == null ) return;
	containing_target_obj.innerHTML = "";
	var s_i = client_search.gate_results_last_index - client_search.number_of_viewed_indexes + 1;
	var e_i = client_search.gate_results_last_index;
	var inner_txt = c_pager_status_str;
	
	var expstr = "%p1";
	var expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace(expobj, s_i.toString() );

	var expstr = "%p2";
	var expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace(expobj, c_pager_numeric_delim );

	var expstr = "%p3";
	var expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace(expobj, e_i.toString());
	
	expstr = "%h";
	expobj = new RegExp( expstr,"g");
	inner_txt = inner_txt.replace(expobj, client_search.total_number_or_results );
	expstr = "%x";
	expobj = new RegExp( expstr,"g");
	if ( client_search.total_number_or_results == 1 )	inner_txt = inner_txt.replace(expobj, c_word_singular_result );
	else	inner_txt = inner_txt.replace(expobj, c_word_plural_result );

	containing_target_obj.innerHTML = inner_txt;
	show_page_objs();
}

function pgr_create_pagers(){					
	if ( client_search == null ) return;
	if ( index_target_obj == null ) return;
	if ( page_next_target_obj == null ) return;
	if ( page_prev_target_obj == null ) return;

	if (( index_target_obj2 == null ) ||
	    ( page_next_target_obj2 == null ) ||
	    ( page_prev_target_obj2 == null  )){
		bSecondPager = false;
	}
	
	var win = index_target_obj.document.parentWindow;
	if ( win == null ) return;
	var page_index_array = client_search.get_page_indexes();
	index_target_obj.innerHTML = "";
	page_next_target_obj.innerHTML = "";
	page_prev_target_obj.innerHTML = "";
	
	if ( bSecondPager ){
		index_target_obj2.innerHTML = "";
		page_next_target_obj2.innerHTML = "";
		page_prev_target_obj2.innerHTML = "";
	}

	var is_first_page = true;

	if ( page_index_array.length > 1 ) {
		for ( var i = 0; i < page_index_array.length; i++ ){
			var span = win.document.createElement( "span" );
			if ( span == null ) return;
			span.className = "resultindexer";
			span.resultindex = page_index_array[i];
			span.innerText = ( i + 1 ).toString() + " ";
			span.tabIndex = (0).toString();		
			if  (( client_search.gate_results_last_index == page_index_array[i] + client_search.max_results_a_page )||
				  (( i == page_index_array.length - 1 ) && ( client_search.gate_results_last_index > page_index_array[i]))){
				span.innerText = "[" + ( i + 1 ).toString() + "]" + " ";
				if ( i > 0 ) is_first_page = false;
			}		
			span = index_target_obj.appendChild( span );
			if ( span == null ) return;
			pgr_attach_paging_obj( "index", span );

			if ( bSecondPager ){

				span = win.document.createElement( "span" );
				if ( span == null ) return;
				span.className = "resultindexer";
				span.resultindex = page_index_array[i];
				span.innerText = ( i + 1 ).toString() + " ";
				span.tabIndex = (0).toString();		
				if  (( client_search.gate_results_last_index == page_index_array[i] + client_search.max_results_a_page )||
					  (( i == page_index_array.length - 1 ) && ( client_search.gate_results_last_index > page_index_array[i]))){
					span.innerText = "[" + ( i + 1 ).toString() + "]" + " ";
					if ( i > 0 ) is_first_page = false;
				}		
				span = index_target_obj2.appendChild( span );
				if ( span == null ) return;
				pgr_attach_paging_obj( "index", span );

			}
		}
	}

	var how_many_next = 0;
	( client_search.left_number_search_results < client_search.max_results_a_page ) ? how_many_next = client_search.left_number_search_results : how_many_next = client_search.max_results_a_page;

	var inner_txt = "";
	var expstr = "%r";
	var expobj = new RegExp( expstr,"g");
	
	if ( how_many_next > 0 ){
		inner_txt = LBL_SEARCHRESULTS_NEXT_LINK;
		if ( how_many_next == 1 ){
			expstr = "%r ";
			expobj = new RegExp( expstr,"g");
			inner_txt = inner_txt.replace(expobj, "" );
		} else {
			expstr = "%r";
			expobj = new RegExp( expstr,"g");
			inner_txt = inner_txt.replace(expobj, how_many_next );
		}
		expstr = "%x";
		expobj = new RegExp( expstr,"g");
		if ( how_many_next == 1 )	inner_txt = inner_txt.replace(expobj, c_word_singular_result );
		else			inner_txt = inner_txt.replace(expobj, c_word_plural_result );
		page_next_target_obj.innerHTML = inner_txt;
		page_next_target_obj.tabIndex = (0).toString();
		pgr_attach_paging_obj( "next", page_next_target_obj );

		if ( bSecondPager ){
			page_next_target_obj2.innerHTML = inner_txt;
			page_next_target_obj2.tabIndex = (0).toString();
			pgr_attach_paging_obj( "next", page_next_target_obj2 );
		}

	}
	
	if ( is_first_page != true ) {
		inner_txt = LBL_SEARCHRESULTS_PREVIOUS_LINK;
		expstr = "%m";
		expobj = new RegExp( expstr,"g");
		inner_txt = inner_txt.replace(expobj, client_search.max_results_a_page.toString() );
		expstr = "%x";
		expobj = new RegExp( expstr,"g");
		inner_txt = inner_txt.replace(expobj, c_word_plural_result );
		page_prev_target_obj.innerHTML = inner_txt;
		page_prev_target_obj.tabIndex = (0).toString();
		pgr_attach_paging_obj( "prev", page_prev_target_obj );

		if ( bSecondPager ){
			page_prev_target_obj2.innerHTML = inner_txt;
			page_prev_target_obj2.tabIndex = (0).toString();
			pgr_attach_paging_obj( "prev", page_prev_target_obj2 );
		}
		
	}

	show_page_objs();

	return;
}

function pgr_attach_paging_obj( type, obj ){
	if ( obj == null ) return false;
	if ( obj.innerText == null ) return false;
	if ( type == null ) type == "next";
	if (( type != "index" ) && ( type != "next" ) && ( type != "prev" )) type == "next"
	var index = 0;
	if ( type == "index" ) {
		if ( obj.resultindex == null ) return false;
		index = obj.resultindex;
	}
	obj.enabled = true;	
	obj.detachEvent("onmouseup", pgr_get_prev_results);
	obj.detachEvent("onmouseup", pgr_get_next_results);
	obj.detachEvent("onmouseup", pgr_get_page_number);
	obj.detachEvent("onkeyup", pgr_keys_get_prev_results);
	obj.detachEvent("onkeyup", pgr_keys_get_next_results);
	obj.detachEvent("onkeyup", pgr_keys_get_page_number);
	obj.detachEvent("onmouseup", pgr_makehotclassprev);
	obj.detachEvent("onmouseover", pgr_makehotclassnext);
	obj.detachEvent("onmouseover", pgr_makehotclasspage);
	obj.detachEvent("onmouseout", pgr_removehotclass);
	obj.detachEvent("onselectstart", pgr_cancelselection);

	var bok = obj.attachEvent("onmouseout", pgr_removehotclass);
	bok = obj.attachEvent("onselectstart", pgr_cancelselection);
	obj.className = "disabledclass";
	if ( type == "next" ) {
		bok = obj.attachEvent("onmouseover", pgr_makehotclassnext );
		bok = obj.attachEvent("onmouseup", pgr_get_next_results);
		bok = obj.attachEvent("onkeyup", pgr_keys_get_next_results);
	} else {
		if ( type == "prev" ) {
			bok = obj.attachEvent("onmouseover", pgr_makehotclassprev );
			bok = obj.attachEvent("onmouseup", pgr_get_prev_results);
			bok = obj.attachEvent("onkeyup", pgr_keys_get_prev_results);
		} else {
			bok = obj.attachEvent("onmouseover", pgr_makehotclasspage );
			bok = obj.attachEvent("onmouseup", pgr_get_page_number);
			bok = obj.attachEvent("onkeyup", pgr_keys_get_page_number);
		}
	}
}

function pgr_cancelselection(){
	event.cancelBubble = true; event.returnValue = false; return false;
}

function pgr_makehotclasspage(){
	event.srcElement.className = "hotclass";
}

function pgr_makehotclassprev(){
	if ( client_search == null ) return;
	if ( ( client_search.gate_results_last_index - client_search.max_results_a_page ) > 0 ) event.srcElement.className = "hotclass";
}

function pgr_makehotclassnext(){
	if ( client_search == null ) return;
	if ( client_search.left_number_search_results > 0 ) event.srcElement.className = "hotclass";
}

function pgr_removehotclass(){
	event.srcElement.className = "disabledclass";
	event.srcElement.enabled = false;
}

function pgr_get_prev_results(){
	if ( client_search == null ) return;
	client_search.search_gate_results_previous();
}

function pgr_get_next_results(){
	if ( client_search == null ) return;
	client_search.search_gate_results_next();
}

function pgr_get_page_number(){
	if ( event.srcElement.resultindex == null ) return;
	if ( client_search == null ) return;
	client_search.search_gate_results_indexof( event.srcElement.resultindex );
}

function pgr_keys_get_prev_results(){
	if( event.keyCode != 13 ) return;
	if ( client_search == null ) return;
	client_search.search_gate_results_previous();
}

function pgr_keys_get_next_results(){
	if( event.keyCode != 13 ) return;
	if ( client_search == null ) return;
	client_search.search_gate_results_next();
}

function pgr_keys_get_page_number(){
	if( event.keyCode != 13 ) return;
	if ( event.srcElement.resultindex == null ) return;
	if ( client_search == null ) return;
	client_search.search_gate_results_indexof( event.srcElement.resultindex );
}