// Copyright  2002 Microsoft Corporation.  All rights reserved.
var NODE_ELEMENT = 1;
var NODE_DOCUMENT = 9;
var xmlparsermode = 0;
var xmlparserversion = 0.0;	
var xmlparsercontrolname = "";
var sUIDArray = new Array();
var nodearray = new Array();
setlatestknownxmlparser();
function getxmlobject(){
	var ret = new ActiveXObject( xmlparsercontrolname );
	ret.async = false; return ret;
}

function setlatestknownxmlparser() {
	var xmltestobj = null;
	var xmltext = '<?xml version="1.0" ?><root></root>';
	xmlparsermode = 0;
	xmlparserversion = 0.0;
	xmlparsercontrolname = "";
	try { 
	    	xmltestobj = new ActiveXObject("Msxml2.DOMDocument.4.0");
		xmltestobj.async = false;
		if ( xmltestobj.loadXML( xmltext ) ) {
			if ( xmlparserversion == 0.0 ) xmlparserversion = 4.0;
			if ( xmlparsercontrolname == "" ) xmlparsercontrolname = "Msxml2.DOMDocument.4.0";
			xmlparsermode++;
		}
	} catch( e ) { ; }
	try { 
	    	xmltestobj = new ActiveXObject("Msxml2.DOMDocument.3.0");
		xmltestobj.async = false;
		if ( xmltestobj.loadXML( xmltext ) ){
			if ( xmlparserversion == 0.0 ) xmlparserversion = 3.0;
			if ( xmlparsercontrolname == "" ) xmlparsercontrolname = "Msxml2.DOMDocument.3.0";
			xmlparsermode++;
		}
	} catch( e ) { ; }
	if ( xmlparsermode < 2 ) {
		try {
	    		xmltestobj = new ActiveXObject("Msxml2.DOMDocument.2.6");
			xmltestobj.async = false;
			if ( xmltestobj.loadXML( xmltext )){
				if ( xmlparserversion == 0.0 ) xmlparserversion = 2.6;
				if ( xmlparsercontrolname == "" ) xmlparsercontrolname = "Msxml2.DOMDocument.2.6";
				xmlparsermode++;
			}
		} catch( e ) { ; }
	}
	if ( xmlparsermode < 2 ) {
		try {
		    	xmltestobj = new ActiveXObject("Msxml2.DOMDocument");
			xmltestobj.async = false;
			if ( xmltestobj.loadXML( xmltext )){
				if ( xmlparserversion == 0.0 ) xmlparserversion = 2.0;
				if ( xmlparsercontrolname == "" ) xmlparsercontrolname = "Msxml2.DOMDocument";
				xmlparsermode++;
			}
		} catch( e ) { ; }
	}
	if ( xmlparsermode < 2 ) {
		try {
	    		xmltestobj = new ActiveXObject("Msxml.DOMDocument");
			xmltestobj.async = false;
			if ( xmltestobj.loadXML( xmltext )){
				if ( xmlparserversion == 0.0 ) xmlparserversion = 1.0;
				if ( xmlparsercontrolname == "" ) xmlparsercontrolname = "Msxml.DOMDocument";
				xmlparsermode++;
			}
		} catch( e ) { ; }
	}
	if ( xmlparsermode == 0 ) return false;
	return true;
}

function xml_load( srcfile, loud ) {
	var rxmlobj = getxmlobject();
	rxmlobj.async = false;
	rxmlobj.resolveExternals = false;
	rxmlobj.validateOnParse = false;
	rxmlobj.load( srcfile );
	
	rdocument = rxmlobj.documentElement;
	if ( rxmlobj.parseError.errorCode != 0 ) {
		if ( loud != null ){
			if ( loud == false )	return null;
		}
		alert("Errors loading results XML data..." + srcfile + "\n" 
			+ " line: " + rxmlobj.parseError.line + "\n"
			+ " " + "linepos: " + rxmlobj.parseError.linepos + "\n"
			+ " " + "filepos: " + rxmlobj.parseError.filepos + "\n"
			+ " " + "url: " + srcfile + "\n'"
			+ rxmlobj.parseError.srcText + "'\n"
			+ rxmlobj.parseError.reason );
		return null;
	}
	
	return rxmlobj;
}

function xml_push_uniquenode( node ) {
	var badd = true;
	for( var i = 0; i < nodearray.length; i++ ) {
		if ( node == nodearray[i] ) {
			badd = false; break;
		}
	}
	if ( badd == true ) nodearray[nodearray.length] = node;
	return badd;
}

function xml_flush_nodes() {
	nodearray.length = 0;
}

function xml_walk_elements( elm, nodetype, seval ) {

	if ( !elm.childNodes ) return;
	for ( var i = 0; i < elm.childNodes.length; i++ ) {
		var node = elm.childNodes[i];
		switch( node.nodeType ) {
			case nodetype:
				if ( xml_push_uniquenode( node ) ) eval(seval);
				break;
			case NODE_ELEMENT:
			case NODE_DOCUMENT:
				xml_walk_elements( node, nodetype, seval );
				break;
			default:
				;
		}
	}
	return 1;
}

function newUID(){
   var strID;
   var bOriginal = false;
   var iMin = 0;

   while(bOriginal == false){
	strID = makeUID();
	bOriginal = true;
	while(iMin < sUIDArray.length){
	   if(sUIDArray[iMin].toLowerCase() == strID.toLowerCase()) bOriginal = false;
	   iMin++;
	}
   }
   sUIDArray[sUIDArray.length] = strID;
   return strID;
}

function makeUID(){
   var newID = "";
   newID = newID + rndHexStr(12);
   return(newID);
}

function rndHexStr( iCnt ){
   var strNewHex = "";
   var sAlphaOrNum;
   var iRnd;
   var iR = 1;
   while(iR <= iCnt){
	iRnd = Math.round(15 * Math.random() + 0);
	if(9 < iRnd && iRnd < 16) sAlphaOrNum = String.fromCharCode(55 + iRnd);
	else sAlphaOrNum = iRnd.toString(16);
	strNewHex = strNewHex + sAlphaOrNum;
	iR = iR + 1;
   }
   return(strNewHex);
}