﻿//////////////////////////////////////////////////////////////////////////////
//
// Copyright © 2002-2003, Microsoft Corporation.  All rights reserved.
//
// File: Viewerstrings.js
//
// Description: Global string constants used throughout the viewer.
//
//////////////////////////////////////////////////////////////////////////////

// meta name="version-stamp" content="LocDrop1"

var LBL_VIEWER_TITLE = "Windows XP Starter Edition Help";

//MV CHANGE - adding bannerlink loc text back in
var LBL_BANNER_LINK = "Go to My Support";
var URI_BANNER_LINK = "../default.htm";
var LBL_BANNER_LINK_TOOLTIP = "Click to go to My Support";
//END MV CHANGE

var LBL_BANNER_LINK_ACCESSKEY = "G";
var LBL_COLLECTION_TITLE = "Microsoft eLearning Collection";
var LBL_TOC_MENU = "Table of Contents";
var LBL_TOC_MENU_ACCESSKEY = "C";
var LBL_TOC_TOOLTIP_SHOW = "Show Table of Contents";
var LBL_TOC_TOOLTIP_HIDE = "Hide Table of Contents";
var LBL_BOOKMARK_MENU = "Bookmark";
var LBL_BOOKMARK_MENU_ACCESSKEY = "B";
var LBL_BOOKMARK_MENUTOOLTIP = "Bookmark";
var LBL_BOOKMARKMENU_ADD = "Add Bookmark";
var LBL_BOOKMARKMENU_MANAGE = "View/Manage Bookmarks";
var LBL_NOTEBOOK_MENU = "Notebook";
var LBL_NOTEBOOK_MENU_ACCESSKEY = "o";
var LBL_NOTEBOOK_MENUTOOLTIP = "Notebook";
var LBL_HELP_MENU = "Help";
var LBL_HELP_MENU_ACCESSKEY = "L";
var LBL_HELP_MENU_TOOLTIP = "Get Help";
var LBL_HELPMENU_VIEWERHELP = "Viewer Help";
var LBL_HELPMENU_ABOUT = "About...";
var LBL_BASIC_SEARCH = "Search for";
var LBL_BASIC_SEARCH_ACCESSKEY = "S";
var LBL_BTN_GO = "GO";
var LBL_ADVANCED_SEARCH = "Advanced Search";
var LBL_ADVANCED_SEARCH_ACCESSKEY = "R";
var LBL_ADVANCED_SEARCH_TOOLTIP = "More Search options";
var LBL_PREVIOUS_TOPIC = "Previous";
var LBL_PREVIOUS_TOPIC_ACCESSKEY = "P";
var LBL_PREVIOUS_TOOLTIP = "Previous page or topic";
var LBL_NEXT_TOPIC = "Next";
var LBL_NEXT_TOPIC_ACCESSKEY = "N";
var LBL_NEXT_TOOLTIP = "Next page or topic";
var LBL_DIVIDER_BAR = "Divider Bar";
var ERR_CANNOT_LOAD_XML_FILE = "The following file could not be loaded by the XML Parser: ";

var LBL_ABOUT_DIALOG_TITLE = "About Viewer";
var LBL_ABOUT_DIALOG_VIEWER_VERSION = "Viewer Version: 1.0";
var LBL_ABOUT_DIALOG_COPYRIGHT = "&copy; 2002-2004 Microsoft Corporation.";
var LBL_ABOUT_DIALOG_ALLRIGHTS = "All rights reserved.";
var LBL_ABOUT_DIALOG_RESTRICTIONS = "For specific use restrictions and requirements, please refer to the Products Use Rights section of your volume licensing agreement.";
var LBL_ABOUT_DIALOG_PID = "Product ID:";
var LBL_ABOUT_DIALOG_WARNING = "Warning: This computer program is protected by copyright law and international treaties. Unauthorized reproduction or distribution of this program, or any portion of it, may result in severe civil and criminal penalties, and will be prosecuted to the maximum extent possible under the law.";
var LBL_ABOUT_DIALOG_CLOSE_BUTTON = "Close";

var LBL_ADDBOOKMARK_DIALOG_TITLE = "Add Bookmark";
var LBL_ADDBOOKMARK_DIALOG_OK_BUTTON = "OK";
var LBL_ADDBOOKMARK_DIALOG_CANCEL_BUTTON = "Cancel";
var LBL_ADDBOOKMARK_DIALOG_INSTRUCTIONS = "Enter your bookmark name above and then click OK to add a bookmark.";
var ERR_ADDBOOKMARK_NO_TEXT = "Please enter a bookmark description.";
var ERR_ADDBOOKMARK_TEXT_LEN = "Bookmark name cannot exceed 256 characters.";
var LBL_ADDBOOKMARKS_CONFIRM_REPLACE = "A link already exists for this item.  Do you want to rename \"%s\"?";

var LBL_MANAGEBOOKMARKS_DIALOG_TITLE = "View/Manage Bookmarks";
var LBL_MANAGEBOOKMARKS_DIALOG_LAUNCH_BUTTON = "Launch";
var LBL_MANAGEBOOKMARKS_DIALOG_DELETE_BUTTON = "Delete";
var LBL_MANAGEBOOKMARKS_DIALOG_CANCEL_BUTTON = "Cancel";
var LBL_MANAGEBOOKMARKS_DIALOG_LAUNCH_BUTTON_ACCESSKEY = "L";
var LBL_MANAGEBOOKMARKS_DIALOG_DELETE_BUTTON_ACCESSKEY = "D";
var LBL_MANAGEBOOKMARKS_CONFIRM_DELETE = "Are you sure you want to delete the link \"%s\"?";
var LBL_MANAGEBOOKMARKS_CONFIRM_MULTI_DELETE = "You have selected %s links for deletion.  Do you want to continue?";
var LBL_MANAGEBOOKMARKS_WARN_MULTI_LAUNCH = "Multiple links cannot be launched.  You must select one item.";

var LBL_CONTENTWHEEL_LISTVIEWBUTTON_TOOLTIP = "List View";
var LBL_CONTENTWHEEL_ICONVIEWBUTTON_TOOLTIP = "Icon View";

var LBL_NAV_HELP_BTN = "Content Navigation";
var LBL_NAV_HELP_DIALOG_TITLE = "Content Navigation";
var LBL_NAV_HELP_DIALOG_HEADING = "Content Navigation";
var LBL_NAV_HELP_DIALOG_TEXT1 = "To navigate through the topics in a lesson, you can use either the <b>Icon View</b>,";
var LBL_NAV_HELP_DIALOG_TEXT2 = "or the <b>Text View</b>";
var LBL_NAV_HELP_DIALOG_TEXT3 = "Use the toggle buttons to move between the two views.";
var LBL_NAV_HELP_DIALOG_TEXT4 = "Icon View";
var LBL_NAV_HELP_DIALOG_TEXT5 = "Text View";
var LBL_NAV_HELP_DIALOG_TEXT6 = "In the <b>Icon View</b>, the content wheel displays the individual topics by content type.";
var LBL_NAV_HELP_DIALOG_TEXT7 = "<b>Read</b> contains text, tables, and graphics.";
var LBL_NAV_HELP_DIALOG_TEXT8 = "<b>Watch</b> contains animations, demonstrations, and videos.";
var LBL_NAV_HELP_DIALOG_TEXT9 = "<b>Interact</b> contains interactive content such as multimedia interactivities and small simulations.";
var LBL_NAV_HELP_DIALOG_TEXT10 = "<b>Play</b> contains games.";
var LBL_NAV_HELP_DIALOG_TEXT11 = "<b>Try</b> includes user-interface simulations or practices that enable you to try what you have learned.";
var LBL_NAV_HELP_DIALOG_TEXT12 = "You can view the topics in whatever order you choose in either the Icon View or the Text View. Notice that the outline remains highlighted for each topic you have visited.";

var LBL_BUTTON_OK = "OK";
var LBL_CONFIG_ERROR_HEADING = "The following errors were detected and must be corrected before using this program:";
var LBL_CONFIG_WARNING_HEADING = "The following items constitute a warning and will not prevent you from using this program, but will lessen your user experience:";
var ERR_UNSUPPORTED_OS_VERSION = "An unsupported operating system has been detected on this computer.  This program requires Microsoft Windows 98 or later, or Windows 2000 or later.";
var ERR_UNSUPPORTED_BROWSER_VERSION = "A current version of Microsoft Internet Explorer is not installed on this computer. If you do not install Microsoft Internet Explorer 5.5 or greater, the viewer may not operate properly. For more information on Microsoft Internet Explorer, visit http://www.microsoft.com/ie. If you are installing this product from a network server, contact your system administrator.";
var ERR_UNSUPPORTED_SCREEN_RESOLUTION = "This program requires a minimum screen resolution of 800x600. To change the screen resolution, right-click your desktop, click Properties on the shortcut menu, click the Settings tab, drag the arrow under Screen resolution until the screen resolution is either equal to or higher than 800x600 pixels, and click OK.";
var ERR_UNSUPPORTED_COLOR_DEPTH = "This program requires High Color (16 bit). To change the color depth, right-click your desktop, click Properties on the shortcut menu, click the Settings tab, increase the color depth, and click OK.";
var ERR_UNSUPPORTED_XMLPARSER = "Microsoft XML Parser 3.0, or later, is required for the viewer to operate properly. For more information on Microsoft XML Parser, visit http://msdn.microsoft.com/xml. To locate and install Microsoft XML Parser 3.0, type xml parser 3 in the Search box of the XML Web Services page, click the Go button, and then click the Download MSXML Parser 3.0 Service Pack 2 link. If you are installing this product from a network server, click the following link: %s.  If you experience a problem during installation, please contact your system administrator.";
var ERR_WRONG_FLASH_VERSION = "Macromedia Flash Player 7.0, or later, is required to view interactive animations. For more information on Macromedia Flash Player, visit http://www.macromedia.com/downloads/. If you are installing this product from a network server, click the following link: %s.  If you experience a problem during installation, please contact your system administrator.";
var ERR_CANNOT_INIT_PLAYER_API = "Unable to initialize the viewer. If you have installed the viewer to your computer, please re-run the Setup program. If you are accessing the viewer from a server, please contact your System Administrator.";
var ERR_CANNOT_FIND_MELL_API = "Unable to locate MELL's SCORM API Adapter.";
var ERR_CANNOT_FIND_EK_API = "Unable to locate ElementK's SCORM API Adapter.";
var ERR_NODE_SELECTION = "Unable to navigate to the specified item.";

var MSG_COMPATIBILITY_TEST = "";
var MSG_LOADING_VIEWER = "";
var MSG_LOADING_MANIFEST = "";
var LBL_PLEASE_WAIT = "Please wait...";

var LBL_CONTROLS_MSG1 = "Please wait while the necessary viewer components are being installed.";
var LBL_CONTROLS_MSG2 = "This process can take several minutes over a low-bandwidth connection.";
var LBL_CONTROLS_MSG3 = "You may be prompted to accept security certificates for these components.";

var ERR_INSTALLING_XMLPARSER = "The installation of the XML Parser (version 3) failed. Please refresh this page to try again or contact your network administrator.";
var ERR_INSTALLING_FLASH = "The installation of the Macromedia Flash (TM) player (version 6) failed. Please refresh this page to try again or contact your network administrator.";
var ERR_NAMESPACE_REDEFINITION = "Warning: Namespace collision encountered!  Please ensure that all namespace URIs are consistent within the same collection.\n\nPreviously declared namespace: %s1\nCurrent namespace declaration: %s2";

var LBL_COURSE_ADVANCED_SEARCH = "Current title selected in the Table of Contents";
var LBL_LIBRARY_ADVANCED_SEARCH = "All titles in the Table of Contents";
var LBL_ADVANCED_SEARCH_ADV = "Advanced Search";
var LBL_SEARCHTYPE_ALL_BOOLEAN = "Boolean";
var LBL_SEARCHTYPE_ALL_WORDS = "All words";
var LBL_SEARCHTYPE_ANY_WORD = "Any word";
var LBL_SEARCHTYPE_EXACT_PHRASE = "Exact phrase";
var LBL_SEARCHINPUT_DISPLAYTEXT = "Search for";
var LBL_BTN_GO_ADVANCED_SEARCH = "Submit query";
var LBL_SEARCHTYPE_DISPLAYTEXT = "Search using";
var LBL_SEARCHSCOPE_DISPLAYTEXT = "Search scope";
var LBL_SEARCHRESULTS_SEARCH_RESULTS = "Search results";
var LBL_SEARCHRESULTS_PREVIOUS_LINK = "<< Previous %m %x";
var LBL_SEARCHRESULTS_NEXT_LINK = "Next %r %x >>";
var LBL_COURSE_SEARCH_RESULTS_SCOPE = "selected title";
var LBL_LIBRARY_SEARCH_RESULTS_SCOPE = "all titles";
var LBL_SEARCH_STANDBY = "Please wait...";
var LBL_SEARCHRESULTS_NO_RESULTS = "No match found.<p>The following guidelines may help you update your search query and find the results you are looking for:</p><ul><li>Check your spelling</li><li>Enter a term or phrase that is less specific</li><li>Try a different phrasing</li><li>Try fewer words</li></ul>";
var LBL_SEARCHRESULTS_NO_INPUT = "You must enter a word or phrase for search to be performed. Please enter a word or a phrase.";

var c_results_numeric_delim = ".";
//MV CHANGE - updates to search
var c_pager_numeric_delim = "&#160;to&#160;";
var c_results_scope_str = "Searched %s for %e1%q%e2 using %t search";
//var c_pager_status_str = "%p out of %h %x";
var c_pager_status_str = "<table cellpadding='0' cellspacing='0'><tr><td>%p1</td><td>%p2</td><td>%p3</td><td>&#160;out of&#160;</td><td>%h</td><td>%x</td></td></table>";
var c_results_collection_link_delim = "<b>Source:</b>";
var c_word_singular_result = "&#160;result&#160;";
var c_word_plural_result = "&#160;results&#160;";
//MV END CHANGE
var c_pager_status_emphasischar1 = "'";
var c_pager_status_emphasischar2 = "'";
var c_result_partial_context = "...";